<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    
    <p></p>

    <script>
        function minhatela(texto){
            document.getElementsByTagName("p")[0].innerText = texto;
        }

        function soma(n1, n2, callBack){
            var res = n1+n2;
            callBack(res);
        }

        soma(5, 2, minhatela);
    </script>


    <script>
        console.log("oi1");

        var ola = () => {
            console.log("oi2");
        }

        setTimeout(ola, 2000);

        console.log("oi3");
    </script>

    <p id="aux"></p>

    <script>
        //EXEMPLO CALLBACK
        var myFunction;
        
        myFunction = () =>{
            var d = new Date();
            document.getElementById("aux").innerHTML = 
                d.getHours() + ":" +
                d.getMinutes() + ":" + 
                d.getSeconds();
        }

        setInterval(myFunction, 1000);
        
    </script>



    <script>
        //EXEMPLO PROMISSE

        var myPromise = new Promise((resolve, reject) => {
            var x = 1   ;

            if(x == 0){
                resolve("ok");
            }else{
                reject("erro");
            }
        })

        myPromise
            .then((value) => {console.log("Minha promise 1 " + value); })
            .then((value) => {console.log("Minha promisse 2")})
            .catch((erro) => {console.log("Deu " + erro); })

        
        myPromise
            .then((value) => {console.log("Minha promisse 1 " + value); })
            .catch((erro) => {console.log("Deu " + erro); })
    </script>
</body>
</html>